#include <iostream>
#include <vector>

using namespace std;

const int max_length = 80;  //  
const int indent = 4;       // 

int main()
{
    size_t number_count, bin_count;
    cerr << "Enter number count: ";
    cin >> number_count;                       //  - 
    vector<double> numbers(number_count);
    cerr << "Enter numbers: " << endl;
    for (int i = 0; i < number_count; i++) {
        cin >> numbers[i];                     //  
    }
    cerr << "Enter bin count: ";
    cin >> bin_count;                          //  - 
    vector<size_t> bins(bin_count);
    for (int i = 0; i < bin_count; i++) {
        bins[i] = 0;
    }
    double min = 5;
    double max = 0;
    for (int i = 0; i < number_count; i++) {   //     
        if (numbers[i] > max) {
            max = numbers[i];
        }
        if (numbers[i] < min) {
            min = numbers[i];
        }
    }
    double bin_size = (max - min) / bin_count; //     
    double step = bin_size;

    for (int i = 0; i < number_count; i++) {
        bool found = false;                                    //    - ,  
        for (int j = 0; (j < bin_count - 1) && !found; j++) {
            double lo = min + j * bin_size;                    //   
            double hi = min + (j + 1) * bin_size;              //   
            if ((lo <= numbers[i]) && (numbers[i] < hi)) {     //      
                bins[j]++;
                found = true;
            }
        }
        if (!found) {
            bins[bin_count - 1]++;
        }
    }

    double max_bin = bins[0];
    int k;
    for (int i = 0; i < bin_count; i++) {             //    bin[]
        if (bins[i] > max_bin) {
            max_bin = bins[i];
        }
    }
    if (max_bin <= (max_length - indent)) {           //    "*"     
        k = 0;
    }
    else {
        k = 1;
    }

    cerr << endl;
    int out;
    for (int i = 0; i < bin_count; i++) {
        cout.width(3);                                          // 
        cout.fill(' ');
        cout << bins[i] << "|";
        if (k == 0) {                                           // 
            out = bins[i];                                      //  
        }
        else {
            out = bins[i] * (max_length - indent) / max_bin;    //  
        }
        for (int j = 0; j < out; j++) {
            cout << "*";
        }
        cout << endl;
    }
    return 0;
}
